// rev 12/06/2009
// 07 mars 09
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.lang.*;
import java.text.*;
import java.util.*;
import javax.swing.JButton;




public class Text_io extends Panel implements Runnable, TextListener {
    private tcpip gtp;
    String S2=new String("");

    String oldmessage = new String("................");
    TextArea input_box  = new TextArea("", 1, 16, 2);
    TextArea output_box = new TextArea("", 1, 80, 2);
    TextArea output_box0 = new TextArea("", 1, 18,2);
    TextArea output_box1 = new TextArea("", 1, 6,2);
    TextArea output_box2 = new TextArea("", 1, 6,2);
    TextArea output_box3 = new TextArea("", 1, 6,2);
    TextArea output_box4 = new TextArea("", 1, 8,2);
    TextArea output_box5 = new TextArea("", 1, 8,2);


    Thread timer;

    public Text_io(tcpip tp) {
        gtp = tp;

        setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
        c.insets =  new Insets(5,25,5,5);
        setBackground(java.awt.Color.lightGray);
        setSize(800,275);
       //input_box
        input_box.addTextListener(this);
        c.gridwidth = 6; c.gridheight = 1;
        c.gridx = 0; c.gridy = 0;
        c.anchor = GridBagConstraints.WEST;
        add(input_box,c);
        c.gridx = 1; c.gridy = 0;
        add((new Label(" vers -> XPORT ->PIC16F877")), c);
        c.fill = GridBagConstraints.NONE;

        c.gridx = 0; c.gridy = 1; c.gridheight = 1;
        add((new Label("Depuis ->PIC -> XPORT")), c);
        c.gridx = 1; c.gridy = 1;
        add(output_box,c);
        output_box.setEditable(false);

        // entree ANA
        c.gridx = 0; c.gridy =2;
        c.anchor = GridBagConstraints.WEST;
        c.fill = GridBagConstraints.NONE;
        add((new Label("Date heure")), c);
        c.gridx = 1; c.gridy =2;
        add((new Label("EA1")), c);
        c.gridx = 2; c.gridy =2;
        add((new Label("EA2")), c);
        c.gridx = 3; c.gridy =2;
        add((new Label("EA3")), c);
        c.gridx = 4; c.gridy =2;
        add((new Label("Lect. Entrees")), c);
        c.gridx = 5; c.gridy =2;
        add((new Label("Etat Sorties")), c);

        c.gridx = 0; c.gridy =3; c.gridwidth =1;
        c.fill = GridBagConstraints.NONE;
        c.anchor = GridBagConstraints.WEST;
        add(output_box0,c);
        output_box0.setEditable(false);
        c.gridx = 1; c.gridy =3;
        add(output_box1,c);
        output_box1.setEditable(false);
        c.gridx = 2; c.gridy =3;
        add(output_box2,c);
         output_box2.setEditable(false);
        c.gridx = 3; c.gridy = 3;
        add(output_box3,c);
         output_box3.setEditable(false);
        c.gridx = 4; c.gridy = 3;
        add(output_box4,c);
         output_box4.setEditable(false);
         c.gridx = 5; c.gridy = 3;
         add(output_box5,c);
         output_box5.setEditable(false);

        timer = new Thread(this);
        timer.start();
    }

    public void run() {
        int i;
        byte[] in;
        Thread me = Thread.currentThread();
        while (timer == me) {
            try {
                Thread.currentThread().sleep(500);
            } catch (InterruptedException e) { }
            if ( (gtp != null) && ((i = gtp.available()) > 0) ) {
                in = gtp.receive();
                /* elimine BS et cars non imprimables  */
                for (i = 0; i < in.length; i++)
                {
                if ((in[i] < 0x0A) && (in[i] != 0x08))  in[i] = 0x20;
                }
                S2=new String(in);
                output_box.setText(S2);

                if ( S2.contains("H"))  // heure et date
                {
                    output_box0.setText(S2.substring(1,18));
                    i=S2.length();
                }
                 if (S2.contains("EA1"))  // CH0 entree ANA
                 {i=S2.indexOf("EA1")+4 ;
                 output_box1.setText(S2.substring(i,i+6));
                }
                 if(S2.contains("EA2"))
                 {
                     i=S2.indexOf("EA2")+4;
                 output_box2.setText(S2.substring(i,i+4));
                }
                if ( S2.contains("EA3"))
                { i=S2.indexOf("EA3")+4;
                 output_box3.setText(S2.substring(i,i+5));
                    }
                 if ( S2.contains("Lec"))
                { i=S2.indexOf("Lec")+4;
                 output_box4.setText(S2.substring(i,i+8));
                    }
                     if ( S2.contains("Ecr"))
                { i=S2.indexOf("Ecr")+4;
                 output_box5.setText(S2.substring(i,i+8));
                    }
            }
        }
    }

    public void textValueChanged(TextEvent e)
    {
        int len, i;

        String str = new String("");
        String message = input_box.getText();
        len = message.length() - oldmessage.length();
        if (len < 0) {
            for (i = 0; i < -len; i++)
                str += "\b";
            System.out.println("Backspace");
        }
        else if (len > 0) {
            str = message.substring(oldmessage.length());
            System.out.println("len = "+str.length()+" str = "+str);
        }
        oldmessage = message;
      // i=str(instr,"E");

       if((message.contains("E")>0) &&(len >9) && (gtp != null) )
          {
		for (i==0; i<8;i++)
               {
		str = message.substring(i);
                  gtp.send(str);
		}
         }
    }

}

